unit TEMainFrm;

{------------------------------------------------------------------------------}
{
  Very simple template editor for "mail merging" (LabelItem Version)
  It loads and saves a template in TEMPLATE.RVF.

  See mail merging application in the same directory - MAILMERGE.

  Main settings:
  - this demo uses a predefined set of styles (right click richviews,
    choose "Settings" from the context menu, choose "Use a predefined
    set of styles"). That means - only two text styles (see below) will be used.
  - rve.Style has two styles:
    0th style - normal text,
    1st - field code (bold, with background)
}
{------------------------------------------------------------------------------}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, RVStyle, RVScroll, RichView, RVEdit, StdCtrls, ExtCtrls,
  RVTypes, RVLabelItem;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Button1: TButton;
    Button2: TButton;
    rve: TRichViewEdit;
    RVStyle1: TRVStyle;
    Button4: TButton;
    procedure Button4Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    procedure InsertField(const FieldCode, DisplayString: TRVUnicodeString;
      TextStyleNo: Integer);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  rve.LoadRVF(ExtractFilePath(Application.ExeName)+'template.rvf');
  rve.Format;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  rve.SaveRVF(ExtractFilePath(Application.ExeName)+'template.rvf', False);
end;
{------------------------------------------------------------------------------}
{ Inserting field.
  FieldCode - field code, saved in item's tag. Main application will search
    field by its code.
  DisplayString - will be displayed in place of field by default. Any string.
  StyleNo - text style for this item, defines font attributes.                 }
procedure TForm1.InsertField(const FieldCode, DisplayString: TRVUnicodeString;
  TextStyleNo: Integer);
var li: TRVLabelItemInfo;
begin
  li := TRVLabelItemInfo.CreateEx(rve.RVData, TextStyleNo, DisplayString);
  li.Tag := FieldCode;
  rve.InsertItem('', li);
end;
{------------------------------------------------------------------------------}
{ Inserting a field "code". }
procedure TForm1.Button1Click(Sender: TObject);
begin
  InsertField('code', '<Code>', 1);
  rve.SetFocus;
end;
{------------------------------------------------------------------------------}
{ Inserting a field "name" }
procedure TForm1.Button2Click(Sender: TObject);
begin
  InsertField('name', '<Name>', 1);
  rve.SetFocus;
end;

end.
